#include <iostream>
#include <stdexcept>
using namespace std;

template< typename Type >
class vetor {
private:
    int tam;
    Type * vet;
public:
    vetor(int tam) throw(runtime_error) : tam(tam) {
        if( tam <= 0 )
            throw runtime_error("Tamanho inválido");
        vet = new Type[tam]; 
    }     
    Type& operator[]( int i ) throw(runtime_error) {
        if( i >= 0 && i < tam )
            return vet[i];
        else
            throw runtime_error("Índice inválido");
    }
    bool operator==( vetor<Type> v ) {
        if( v.tamanho() != tamanho() )
            return false;
        for(int i = 0; i < tamanho(); i++ )
            if( v.vet[i] != vet[i] )
                return false;
        return true;
    }
    int tamanho() {
        return tam;
    }
};
// Especialização
template<>
class vetor< float > {
private:
    int tam;
    float * vet;
public:
    vetor(int tam) throw(runtime_error) : tam(tam) {
        if( tam <= 0 )
            throw runtime_error("Tamanho inválido");
        vet = new float[tam]; 
    }     
    float& operator[]( int i ) throw(runtime_error) {
        if( i >= 0 && i < tam )
            return vet[i];
        else
            throw runtime_error("Índice inválido");
    }
    bool operator==( vetor<float> v ) {
        if( v.tamanho() != tamanho() )
            return false;
        for(int i = 0; i < tamanho(); i++ )
            if( v.vet[i] != vet[i] )
                return false;
        return true;
    }
    
    float sum() {
        float s = 0;
        for(int i =0; i < tam; i++ )
            s += vet[i];
        return s;
    }
    
    int tamanho() {
        return tam;
    }
};

int main() {
    
    try {
        vetor< float > v( 4 );
        v[0] = 5.8934;
        cout << v.sum() << endl;
        
    } catch( runtime_error e ) {
        cout << e.what() << endl;
    }
    
    
}
